#!/bin/sh
# $Id: zbatchsmtp.SH,v 1.3 1998/02/03 16:19:28 moritz Exp $

# deliver messages accumlated into subdirectories of the
# z-outq spool directory.  Subdirectory names are based on
# the actual hostnames involved (including full domain!)

LOCK=@SPOOLDIR@/locks/zbatchsmtp.lck

trap "rm -f $LOCK.$$; exit 0" 0 1 2 3

echo $$ > $LOCK.$$
if (umask 222; ln $LOCK.$$ $LOCK) 2>/dev/null
then
	# OK -> Datei gab es noch nicht
	trap "rm -f $LOCK $LOCK.$$; exit 0" 0 1 2 3 
	rm -f $LOCK.$$
else
	# Fehler -> Lock existierte
	echo "$0: es laeuft bereits ein anderer Prozess" >&2
	ls -l $LOCK >&2
	exit 0
fi

LOCALHOST=@FQDN@
MAXSIZE=100000

SMAILSPOOL="`smail -bP spool_dirs`"
if [ "x$SMAILSPOOL" = x ]; then SMAILSPOOL=/usr/spool/smail; fi
OUTQ=$SMAILSPOOL/z-outq
PATH=$PATH:@PATHADD@:@DESTDIR@; export PATH

cd $OUTQ || exit 1

# loop through all of the subdirectories
for host in *
do
    (
	# change to directory or exit subshell
	test -d $host || exit
	cd $host || exit 1

	# send multiple batches
	while :
	do
		# get the list of message files; quit if none
		msgs="`ls 2>/dev/null | grep '^q'`"
		test -n "$msgs" || break

		# accumulate until total size exceeds maximum
		send=
		sz=0
		for f in $msgs
		do
			send="$send $f"
			n=`wc -c <$f 2>/dev/null`
			test -n "$n" || continue
			sz=`expr $sz + $n`
			test $sz -lt $MAXSIZE || break
		done

		# send messages, adding HELO and QUIT commands
		( echo "HELO $LOCALHOST"
		  for f in $send
		  do
			  cat $f
		  done
		  echo QUIT ) | uursmtp -f $host

		if [ $? -eq 0 ]
		then

			# remove messages that were sent
			for f in $send
			do
				rm $f
			done
		fi
	done
    )
done

exit 0
